=== debian/changelog ===
libpgm (5.3.128~dfsg-2) unstable; urgency=medium

  * Upload to unstable for library transition.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 10 Oct 2020 18:00:12 +0200

libpgm (5.3.128~dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Library transition from libpgm-5.2-0 to libpgm-5.3-0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 03 Sep 2020 17:33:48 +0200

libpgm (5.2.122+git20200619~dfsg-2) unstable; urgency=medium

  * Make pgm_family_string() inline (closes: #968642).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 19 Aug 2020 20:36:48 +0200

libpgm (5.2.122+git20200619~dfsg-1) unstable; urgency=medium

  * Git snapshot release:
    - update for Python 3 (closes: #967165).
  * Update patches.
  * Update libpgm-5.2-0 symbols.
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 17 Aug 2020 19:48:27 +0200

libpgm (5.2.122~dfsg-3) unstable; urgency=medium

  * Update watch file.
  * Update debhelper level to 11:
    - remove dh-autoreconf build dependency,
    - don't specify parallel to debhelper.
  * Update Standards-Version to 4.3.0:
    - remove libpgm-dbg package and use the auto-generated one.

  [ Luca Boccassi <bluca@debian.org> ]
  * pkg-config: do not add -I to non-existing directory (closes: #920259).
  * version_generator.py: make build reproducible (closes: #920271).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 24 Jan 2019 18:34:08 +0000
