=== debian/control ===
Source: libpgm
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 11), python3
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/steve-o/openpgm

Package: libpgm-5.3-0
Architecture: any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenPGM shared library
 OpenPGM is an open source implementation of the Pragmatic General Multicast
 (PGM) specification in RFC 3208 available at www.ietf.org. PGM is a reliable
 and scalable multicast protocol that enables receivers to detect loss,
 request retransmission of lost data, or notify an application of
 unrecoverable loss. PGM is a receiver-reliable protocol, which means the
 receiver is responsible for ensuring all data is received, absolving the
 sender of reception responsibility. PGM runs over a best effort datagram
 service, currently OpenPGM uses IP multicast but could be implemented above
 switched fabrics such as InfiniBand.
 .
 This is the runtime package for programs that use the OpenPGM library.

Package: libpgm-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpgm-5.3-0 (= ${binary:Version}), ${misc:Depends}
Conflicts: libnetpbm9-dev
Description: OpenPGM development files
 OpenPGM is an open source implementation of the Pragmatic General Multicast
 (PGM) specification in RFC 3208 available at www.ietf.org. PGM is a reliable
 and scalable multicast protocol that enables receivers to detect loss,
 request retransmission of lost data, or notify an application of
 unrecoverable loss. PGM is a receiver-reliable protocol, which means the
 receiver is responsible for ensuring all data is received, absolving the
 sender of reception responsibility. PGM runs over a best effort datagram
 service, currently OpenPGM uses IP multicast but could be implemented above
 switched fabrics such as InfiniBand.
 .
 This is the development package which contains headers and static libraries
 for the OpenPGM library.
